\ List the files in the root directory
: ls
  spi_rootdir @
  begin
    dup spi_buf spi_readblock drop
    512 0 do
      i spi_buf + dup c@
      if
        dup c@ 229 =           \ Deleted file
        over 11 + c@ 15 = or   \ Long name
        if
          drop
        else
          dup 11 type bl emit
          dup 28 + brlong .
          cr drop
        then
      else
        r> r> 2drop 2drop exit
      then
    32 +loop
    1+
  again
;

\ Type the file to the console
: cat bl word count 0 open-file swap drop
  if
    ." Could not open file" cr
  else
    begin
      pad 100 0 read-line drop
      0 = if drop exit then
      pad swap type cr
    again
  then
;

\ Copy the file to another file
: cp bl word count 0 open-file swap drop
  if
    ." Could not open file" cr
  else
    here unused 0 read-file 2drop
    bl word count 0 create-file 2drop
    here swap 0 write-file drop
    0 close-file drop
  then
;

: rm bl word count delete-file
  if
    ." File does not exist" cr
  then
;
