\ List the files in the root directory
: list-files
  spi_rootdir @
  begin
    dup spi_buf spi_readblock drop
    512 0 do
      i spi_buf + dup c@
      if
        dup c@ 229 =
        if
          drop
        else
          dup 11 type bl emit
          \ dup 11 + c@ .
          \ dup 26 + brword .
          dup 28 + brlong .
          cr drop \ 11 + 21 dump
        then
      else
        r> r> 2drop 2drop exit
      then
    32 +loop
    1+
  again
;

\ Line Type the file to the console
: type-file bl word count 0 open-file swap drop
  if
    ." Could not open file" cr
  else
    begin
      pad 100 0 read-line drop
      \ .s cr
      0 = if drop exit then
      pad swap type cr
    again
  then
;

: print_allocated_clusters
  spi_fat1 @ spi_sectorsperfat @ 0 ?do
    dup spi_buf spi_readblock drop
    1+
    512 0 do
      spi_buf i + w@ dup
      if
        j 256 * i 2 / + . . cr
      else
        drop
      then
    2 +loop
  loop
  drop
;

: create_file 32 word count 0 create-file drop drop ;

: open_file 32 word count 0 open-file drop drop ;

: dump_file
  ." file_sector0   " file_sector0   ? cr
  ." file_sector    " file_sector    ? cr
  ." file_length    " file_length    ? cr
  ." file_position  " file_position  ? cr
  ." file_remaining " file_remaining ? cr
  ." file_dsector   " file_dsector   ? cr
  ." file_doffset   " file_doffset   ? cr
  ." file_dirty     " file_dirty     ? cr
  ." file_opened    " file_opened    ? cr
;
